---
title: 'RTCPeerConnection: icecandidateerror event'
slug: Web/API/RTCPeerConnection/icecandidateerror_event
tags:
  - API
  - Connection
  - Connectivity
  - Event
  - Failure
  - ICE
  - Networking
  - RTCPeerConnection
  - Reference
  - STUN
  - TURN
  - WebRTC
  - WebRTC API
  - WebRTC Device API
  - icecandidateerror
---
<p>{{DefaultAPISidebar("WebRTC")}}</p>

<p>The <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a> event <code><strong>icecandidateerror</strong></code> is sent to an {{domxref("RTCPeerConnection")}} if an error occurs while performing ICE negotiations through a {{Glossary("STUN")}} or {{Glossary("TURN")}} server. The event object is of type {{domxref("RTCPeerConnectionIceErrorEvent")}}, and contains information describing the error in some amount of detail.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("RTCPeerConnectionIceErrorEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCPeerConnection.onicecandidateerror")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Description">Description</h2>

<p>The error object's {{domxref("RTCPeerConnectionIceErrorEvent.errorCode", "errorCode")}} property is one of the numeric STUN error codes. There is one additional, WebRTC-specific, error which lies outside the valid STUN error code range: 701. Error 701 indicates that none of the ICE candidates were able to successfully make contact with the STUN or TURN server.</p>

<p>The 701 error is fired only once per server URL from the list of available STUN or TURN servers provided when creating the {{domxref("RTCPeerConnection")}}. These errors occur only when the connection's <a href="/en-US/docs/Web/API/RTCPeerConnection/iceGatheringState">ICE gathering state</a> is <code>gathering</code>.</p>

<h2 id="Example">Example</h2>

<p>The following example establishes a handler for <code>icecandidateerror</code>s that occur on the {{domxref("RTCPeerConnection")}} <code>pc</code>. This handler looks specifically for 701 errors that indicate that candidates couldn't reach the STUN or TURN server.</p>

<p>When this happens, the server URL and the error message are passed to a function called <code>reportConnectFail()</code> to log or output the connection failure.</p>

<pre class="brush: js notranslate">pc.addEventListener("icecandidateerror", (event) =&gt; {
  if (event.errorCode === 701) {
    reportConnectFail(event.url, event.errorText);
  }
});
</pre>

<p>Note that if multiple STUN and/or TURN servers are provided when creating the connection, this error may happen more than once, if more than one of those servers fails. Each provided server is tried until a connection is established.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#event-icecandidateerror', 'icecandidateerror')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCPeerConnection.icecandidateerror_event")}}</p>
</div>
